﻿Module Main
    Sub Main()
        Dim book As New Workbook(WorkbookFormat.Excel2007)
        Dim sheet As Worksheet = book.Worksheets.Add("Sample Error")

        ImportCsv(sheet)

        Try
            For Each row As WorksheetRow In sheet.Rows
                For Each cell As WorksheetCell In row.Cells
                    'This causes the error
                    cell.CellFormat.Font.Name = "Trebuchet MS"
                Next
            Next
        Catch ex As Exception
            MsgBox(ex.StackTrace)
        End Try

        book.Save("..\..\test.xlsx")
    End Sub

    ''' <summary>
    ''' Imports data from the csv file into the worksheet
    ''' </summary>
    Private Sub ImportCsv(ByVal sheet As Worksheet)
        Dim fields() As String
        Dim col As Integer
        Dim row As Integer

        Using reader As New FileIO.TextFieldParser("..\..\SampleData.csv")
            reader.TextFieldType = FileIO.FieldType.Delimited
            reader.SetDelimiters(",")
            reader.TrimWhiteSpace = False

            While Not reader.EndOfData
                Try
                    fields = reader.ReadFields

                    For col = 0 To fields.Length - 1
                        'For null value or empty fields, leave column blank
                        If fields(col) = "?" OrElse
                           fields(col) = "" Then
                            Continue For
                        End If

                        'Header row is always imported as character data
                        If row = 0 Then
                            sheet.Rows(row).Cells(col).Value = fields(col)
                        Else
                            Try
                                Select Case col
                                    Case 0 To 10, 17 To 21, 26, 33 To 38
                                        'These columns are character datatype
                                        'A-K, R-V, AA, AH-AM
                                        sheet.Rows(row).Cells(col).Value = fields(col)

                                    Case 39
                                        'This column is date datatype
                                        'AN
                                        sheet.Rows(row).Cells(col).Value = CDate(fields(col))

                                    Case Else
                                        'Remaining columns are decimal datatype
                                        sheet.Rows(row).Cells(col).Value = CDec(fields(col))

                                End Select
                            Catch ex As Exception
                                'Error occured, just write text value
                                sheet.Rows(row).Cells(col).Value = fields(col)
                            End Try
                        End If
                    Next

                    row += 1
                Catch ex As FileIO.MalformedLineException
                    MsgBox("Line " & ex.Message & " is not valid and will be skipped")
                End Try
            End While
        End Using
    End Sub
End Module
